VisualEditor: Display a link to both VE and wikitext editor on every section header
Closed, ResolvedPublic

Description

[From bug 48429 comment 18]

It would be ideal to have section-edit links for [edit] and [edit source].
ie.
Sandbox [edit]
replaced with:
Sandbox [edit] [edit source]
I believe this would prevent a LOT of complaints in the short term, and it
would permit a lot of us to continue being active beta testers
(section-editing is my most frequent type of edit), that it should be High
priority, if at all possible. Thanks.

Version: unspecified
Severity: normal
See Also:
https://bugzilla.wikimedia.org/show_bug.cgi?id=48429
https://bugzilla.wikimedia.org/show_bug.cgi?id=49621
https://bugzilla.wikimedia.org/show_bug.cgi?id=47779
https://bugzilla.wikimedia.org/show_bug.cgi?id=56337

bzimport set Reference to bz49666.
Jdforrester-WMF created this task.Via LegacyJun 17 2013, 12:52 AM
Quiddity added a comment.Via ConduitJun 17 2013, 1:06 AM

See comment 23 and 24, at Bug 48429 wherein Bartosz Dziewoński has submitted a patch to Gerrit.

("https://gerrit.wikimedia.org/r/68868 (Gerrit Change
I13bbb9549c999bb7301bbcf530706a813184425d)")

If his patch isn't accepted, then I would again urge High Priority for an alternative fix.

bzimport added a comment.Via ConduitJun 17 2013, 12:36 PM

zedlightman wrote:

There is much discussion at bug 48429 about the need for both types of edit links on every header.

What might also work is an "edit" link (for VisualEditor) and an icon that when clicked will take one to the source editor for that section. The icon would have a popup tooltip that says "edit source". It would show up when the mouse cursor is run over the icon.

Jdforrester-WMF added a comment.Via ConduitJun 17 2013, 7:53 PM

(In reply to comment #2)

There is much discussion at bug 48429 about the need for both types of edit
links on every header.

What might also work is an "edit" link (for VisualEditor) and an icon that
when
clicked will take one to the source editor for that section. The icon would
have a popup tooltip that says "edit source". It would show up when the mouse
cursor is run over the icon.

My concern with this area is three fold:

  • "[edit] [edit source]" is a huge amount of extra chrome/clutter to enable for all users
  • "[edit]" going to one place unless you've got a preference in which case it goes to another is… confusing
  • "[edit]" OR "[edit source]" if you've got a preference is a bit messy, but not that bad

I like "[edit ⚙]" more - what do you think? MatmaRex discussed this with me last night.

Mattflaschen added a comment.Via ConduitJun 17 2013, 8:00 PM

(In reply to comment #3)

I like "[edit ⚙]" more - what do you think? MatmaRex discussed this with me
last night.

So if you click 'edit', it always goes to VE, and if you click ⚙ (first time I saw the 'gear' character, but good usage), it always goes to wikitext?

That seems reasonable if the wikitext target is big enough that it's not frustrating to click.

Jdforrester-WMF added a comment.Via ConduitJun 18 2013, 12:28 AM

Having discussed, we think we've found a design that's consistent with other usage: instead of having "[edit | edit source]" or "[edit ⚙]", we will have "[edit ▾]" with the down-arrow expanding to a menu (in the same way that Vector does) for "edit source"). This is still easily accessible for users and open for all users, not just those with a preference, but does not take lots of screen estate (problem with the first possibility), and is easily discoverable (second possibility).

Mattflaschen added a comment.Via ConduitJun 18 2013, 12:46 AM

I like this idea. It would be nice if it worked for at least Monobook (in addition to Vector).

Jdforrester-WMF added a comment.Via ConduitJun 18 2013, 1:35 AM

(In reply to comment #6)

I like this idea. It would be nice if it worked for at least Monobook (in
addition to Vector).

Completely agree. Not sure quite whether this treatment is suitable for Monobook or whether we should invent a different one there?

bzimport added a comment.Via ConduitJun 18 2013, 1:48 AM

swalling wrote:

  • "[edit]" going to one place unless you've got a preference in which case it goes to another is… confusing
  • "[edit]" OR "[edit source]" if you've got a preference is a bit messy, but not that bad

Personally I think one of these two are the only viable options. The dropdown arrow or cog is too much unnecessary choice. The point of section edit links is to enable speedy editing of single sections, so introducing a dropdown is overloading things. Most new editors will appreciate defaulting to VE, and for power users who need edit source, this is where having a preference to change your default to edit source would come in handy (a preference I am guessing would free us up to also move "Edit source" at the top of the page in to a dropdown).

Jdforrester-WMF added a comment.Via ConduitJun 18 2013, 1:55 AM

(In reply to comment #8)

> * "[edit]" going to one place unless you've got a preference in which case it
> goes to another is… confusing
>
> * "[edit]" OR "[edit source]" if you've got a preference is a bit messy, but
> not that bad

Personally I think one of these two are the only viable options. The dropdown
arrow or cog is too much unnecessary choice. The point of section edit links
is to enable speedy editing of single sections, so introducing a dropdown is
overloading things. Most new editors will appreciate defaulting to VE, and
for power users who need edit source, this is where having a preference to
change your default to edit source would come in handy (a preference I am
guessing would free us up to also move "Edit source" at the top of the page in
to a dropdown).

I disagree. I would say that, as an axiom, preferences are bad; they add complexity for coders (expensive), bug testers (irritating) and most importantly users (alienating).

In this case, we would also lose momentum as many power users might early-on opt out of VisualEditor for section edits, and so never use it as much as we'd hope. We would lose their input, their bug reports and most importantly their enculturation for new users of this being the 'right' way to edit. We don't want another Vector roll-out disaster on our hands; ever day that Monobook remains on the servers is another notch on that failure yardstick. :-(

bzimport added a comment.Via ConduitJun 18 2013, 2:08 AM

swalling wrote:

(In reply to comment #9)

(In reply to comment #8)
> > * "[edit]" going to one place unless you've got a preference in which case it
> > goes to another is… confusing
> >
> > * "[edit]" OR "[edit source]" if you've got a preference is a bit messy, but
> > not that bad
>
> Personally I think one of these two are the only viable options. The dropdown
> arrow or cog is too much unnecessary choice. The point of section edit links
> is to enable speedy editing of single sections, so introducing a dropdown is
> overloading things. Most new editors will appreciate defaulting to VE, and
> for power users who need edit source, this is where having a preference to
> change your default to edit source would come in handy (a preference I am
> guessing would free us up to also move "Edit source" at the top of the page in
> to a dropdown).

I disagree. I would say that, as an axiom, preferences are bad; they add
complexity for coders (expensive), bug testers (irritating) and most
importantly users (alienating).

In this case, we would also lose momentum as many power users might early-on
opt out of VisualEditor for section edits, and so never use it as much as
we'd
hope. We would lose their input, their bug reports and most importantly their
enculturation for new users of this being the 'right' way to edit. We don't
want another Vector roll-out disaster on our hands; ever day that Monobook
remains on the servers is another notch on that failure yardstick. :-(

On the other hand, you potentially distract and confuse the heck out of new users by presenting a dropdown to edit source when they were about click edit. The conceptual difference between "edit" and "edit source" is not crystal clear to people who don't know the differences between VE and wikitext up front.

There are also a lot of section edits on most large articles, sometimes in close succession. I think we should be really cautious about enabling multi-level controls and options on something this ubiquitous on a single page.

Mattflaschen added a comment.Via ConduitJun 18 2013, 2:10 AM

(In reply to comment #8)

Personally I think one of these two are the only viable options. The dropdown
arrow or cog is too much unnecessary choice.

I was assuming if you just click 'edit', it would do the same thing as clicking 'edit' up top (i.e. VE for those users with VE enabled). Only if you click the arrow would you see the choice.

Most new editors will appreciate defaulting to VE, and
for power users who need edit source, this is where having a preference to
change your default to edit source would come in handy (a preference I am
guessing would free us up to also move "Edit source" at the top of the page in
to a dropdown).

As a power user, I agree with James. Having both available on every section greatly increases the odds I'll continue to test VE when possible (and report bugs), while using wikitext when I know I have to. Having power users opt out for all VE section edits is not conducive to that.

Mattflaschen added a comment.Via ConduitJun 18 2013, 2:14 AM

(In reply to comment #11)

I was assuming if you just click 'edit', it would do the same thing as
clicking 'edit' up top (i.e. VE for those users with VE enabled). Only if you
click the arrow would you see the choice.

If we do want to avoid the drop-down for non-power users, one idea is to have the preference be like this (possible default shown)

[✓] Show VisualEditor section link

  • Show wikitext section link

You could check either, both (in which case you get some control for choosing, possibly the drop-down), or neither (no section links, which is already an option).

Jdforrester-WMF added a comment.Via ConduitJun 18 2013, 2:15 AM

(In reply to comment #11)

(In reply to comment #8)
> Personally I think one of these two are the only viable options. The dropdown
> arrow or cog is too much unnecessary choice.

I was assuming if you just click 'edit', it would do the same thing as
clicking 'edit' up top (i.e. VE for those users with VE enabled). Only if
you click the arrow would you see the choice.

Yes, that's exactly our plan - sorry if this wasn't clear. It's available, but not intrusive, and if you click the word "edit" link you'll end up in VE at that section.

Quiddity added a comment.Via ConduitJun 18 2013, 2:19 AM

I agree with James and Matthew on this.

A preferences toggle, is for things you want to change permanently.

Whereas this is an instance where I might use VE-section-edit, and use source-section-edit, many times each day, for many months to come.

I really like the arrow-dropdown idea. The cog idea is also good, but would be my second choice.

The only other short options would be [edit (source)] or [edit (code)], but they're not perfect.

Jdforrester-WMF added a comment.Via ConduitJun 18 2013, 3:52 AM

(In reply to comment #14)

The only other short options would be [edit (source)] or [edit (code)], but
they're not perfect.

The main problem with that route (which I should have listed, sorry) is that though "Edit (source)" works OK in English, it's not a safe expectation for non-English languages to be able to split the actions into two call-to-action labels, one of which is a left sub-string of the first, sadly. Also, it's a bit clunky.

bzimport added a comment.Via ConduitJun 18 2013, 4:24 AM

zedlightman wrote:

I like these bracket icons for the edit source links on headers:
[[commons:User:Timeshifter/Sandbox 10]]

matmarex added a comment.Via ConduitJun 18 2013, 8:26 AM

(In reply to comment #7)

(In reply to comment #6)
> I like this idea. It would be nice if it worked for at least Monobook (in
> addition to Vector).

Completely agree. Not sure quite whether this treatment is suitable for
Monobook or whether we should invent a different one there?

The section edit links look the same in all skins, this shouldn't look bad. Monobook already has some Vector-y bits tacked on top and this would be just a small icon.

(In reply to comment #10)

There are also a lot of section edits on most large articles, sometimes in
close succession. I think we should be really cautious about enabling
multi-level controls and options on something this ubiquitous on a single
page.

I'm afraid this doesn't support your argument :)

Only showing one link will prevent users from editing sections of wikitext until they learn to disable the option (or just disable VE entirely), which has been my point all along. Wikitext section editing is the "default" mode of operation for many users (at a quick glance at recent changes, around 30-50% of en.wp edits are section edits) and it'd be awful for VE to make it unaccessible.

Isarra added a comment.Via ConduitJun 20 2013, 3:47 PM

Using an arrow is unintuitive and confusing (no indication what the arrow is actually for; can cause the user to expect the word next to it to be the label for the dropdown, not a separate option entirely especially given the way such arrows operate elsewhere in the skin; results in an extra step/click for something that really might as well be right there; etc). Also doesn't make sense when there are only two options anyway. Just do what James said at the beginning and put in two links.

Later they can stick the edit source option into a tab or something in VE itself, but for now there is no reason to overcomplicate things elsewhere.

Good:

Sandbox [edit] [edit source]

bzimport added a comment.Via ConduitJun 20 2013, 4:53 PM

zedlightman wrote:

Edit. Edit source [[]].

Edit. [[]].


Edit source [[]]. - At the top of the page. This should be one link covering both the text and the icon.

That way people are introduced to the shortcut icon for "edit source". One possibility: [[]]

Headers will have just the shortcut icon link for "edit source": [[]]

Some possibilities for the icon are found here:
*[[commons:User:Timeshifter/Sandbox 10]]

The graphics lab can quickly produce different icons and variations:
*[[Wikipedia:Graphics Lab]]
*[[Wikipedia:Graphics Lab/Illustration workshop]]

Jdforrester-WMF added a comment.Via ConduitJun 21 2013, 3:15 PM
  • Bug 49950 has been marked as a duplicate of this bug. ***
Jdforrester-WMF added a comment.Via ConduitJun 26 2013, 8:46 PM

This was done in gerrit 69984 which is now merged and will go out this afternoon. Thanks, MatmaRex!

Qgil added a comment.Via ConduitJun 27 2013, 6:00 AM

I was doing my volunteering editing at http://ca.wikipedia.org when all of a sudden I realized the new section double-editing links...

Well done! I'm glad about everything I said against them, but it is true that I'm also glad about your implementation. A good bridge indeed.

Quiddity added a comment.Via ConduitJun 27 2013, 6:03 AM

Huge thanks. This looks and acts wonderfully. A good mix of minimal-visuals and maximal-options. Much <3

bzimport added a comment.Via ConduitJun 27 2013, 6:03 AM

swalling wrote:

(In reply to comment #22)

I was doing my volunteering editing at http://ca.wikipedia.org when all of a
sudden I realized the new section double-editing links...

Well done! I'm glad about everything I said against them, but it is true that
I'm also glad about your implementation. A good bridge indeed.

+1. If we have to live with both edit/edit source for now, this is a pretty elegant implementation.

bzimport added a comment.Via ConduitJun 27 2013, 7:13 PM

zedlightman wrote:

Edit and edit source links so confusing I had to disable Visual Editor in preferences today. So you have lost another beta tester. A good one too since I have written many comments and bug reports about VE here and on the Wikipedia feedback page.

I disabled Visual Editor (VE) in preferences today due to constantly clicking the "edit" link instead of the "edit source" link. I am talking about section editing.

The source editing link only shows up after unintuitively mousing over the edit link and so I am constantly clicking the wrong link.

I almost always prefer editing with the source editor since I make frequent edits to tables, images, navboxes, templates, and reference formatting. All at a deep level of formatting, placement, refactoring, etc.. I am very fast in the source editor, and VE only edits partially and poorly at deeper levels, if at all.

It would be better to use an icon for the "edit source" links for sections. For ideas:
*[[commons:User:Timeshifter/Sandbox 10]]
*[[commons:Category:Square brackets]]
*[[commons:Category:MediaWiki brackets]]

"edit source" can show up after mousing over the icon. That is much more intuitive. I did not notice the "edit source" link at all for awhile, since I was rapidly clicking the edit link.

This could drive away many editors. Anonymous editors especially. They have no ability to fix the problem by turning off visual editor in preferences. Many anonymous editors just do not like to log in, and are very used to editing in source editor. Some will be very irritated by the confusing clicking and mousing, just like me.

Jdforrester-WMF added a comment.Via ConduitJun 27 2013, 7:56 PM

This matter is fixed. If you want to suggest additional/alternative implementations, please open a new feature request, not re-open a closed one.

bzimport added a comment.Via ConduitJun 27 2013, 11:15 PM

zedlightman wrote:

Saying it is fixed does not make it fixed. The link is hidden, and so I don't consider it "displayed" as per the current title of this bugzilla thread: "VisualEditor: Display a link to both VE and wikitext editor on every section header".

And you did not address my points. I don't want to start another Bugzilla thread, and have to repeat everything there that was written here. Several people in this thread pointed out their dislike of multi-stage processes to be able to click an "edit source" link.

I am concerned about anonymous editors. I know at some point it is likely an option will be provided in preferences to provide registered editors with a direct "edit source" link and/or clickable icon (maybe with explanatory tooltip).

But unless a direct "edit source" and/or clickable icon link is provided to anonymous editors, then some anonymous editors will edit less. Just like I edited less today, and almost quit editing altogether for the day, due to my annoyance with this multi-stage method, and the many times I messed up.

The point of the visual editor is to get people to edit more, not less. It should not get in the way of editing. It should aid editing.

Wikia refused to provide registered editors an option to put the source editor tab on top of the visual editor tab. So people had to do a multi-stage process for every single edit in order to get to the source editor. Click edit, then wait tediously for visual editor to load, then click the source tab. For every edit... So many, if not most, regular editors disabled the visual editor in preferences. Feedback and bug reports lessened, especially the best feedback from the best editors.

Similar to here now. I have to use a multi-stage process to get to the source editor. Aim at "edit" link or the line it is on, mouse over that "edit" link or line, aim better if necessary, wait for "edit source" link to show up, move mouse over to that link, click. Many times I accidentally, or by habit, click the edit link, and then have to click the back button, and start over. So I have to disable the Visual Editor.

Here is a possible icon method. "Edit source" tooltip can show up after mousing over the icon. And the small icon can have a transparent left and right border that makes the area wider for mousing over. So people will have no problem understanding that the icon is an "edit source" link. The visible part of the icon will be small, similar in size to the watchlist star at the top of pages. But the clickable part would extend to the left and right a bit to allow easier clicking.

Mattflaschen removed a subscriber: Mattflaschen.Via WebDec 3 2014, 5:35 AM

Add Comment